Etherlab master patchset 20160804
=================================

This is an unofficial patchset maintained by Gavin Lambert <gavinl@compacsort.com>.

Patches in the set were contributed by various authors; examine the patches themselves for more information.

The patchset is currently based on revision [5a70ff] (default branch) of the [IgH EtherCAT Master library](http://etherlab.org/en/ethercat/index.php).
[5a70ff]:https://sourceforge.net/p/etherlabmaster/code/ci/5a70ffc4644b59f75e7ced87dcbc43fd04cffbea/tree/

The patchset has been tested and should be safe for use.  However neither the patches nor the patchset is *stable*, in the sense that future versions of the patchset may add, remove, or modify existing patches; although other than as needed to resolve bugs this should normally only occur when rebasing the patches against upstream changes.

In some cases you might want to use only a subset of patches. The code should compile and run if you stop at any point (apply all patches prior to a given patch and none afterwards).  Other combinations of patches may produce fuzz or fail to apply or fail to compile or work, depending on the dependencies and overlap of the individual patches selected.

Feedback on the patchset should be posted to the [etherlab-dev mailing list](http://lists.etherlab.org/mailman/listinfo/etherlab-dev).  Remember to mention which version of the patchset you are using.

Using the patches
-----------------

1. Install Mercurial, if you don't already have it, eg:

        sudo apt-get install mercurial

2. Create or edit your `~/.hgrc` file and ensure it has at least the following contents:

        [extensions]
        mq =

3. Clone the main upstream repository:

        hg clone -u 5a70ffc4 http://hg.code.sf.net/p/etherlabmaster/code etherlab

4. Clone the patch repository:

        hg clone http://hg.code.sf.net/u/uecasm/etherlab-patches etherlab/.hg/patches

5. Apply the patches:

        cd etherlab
        hg qpush -a

6. You're now ready to build, as usual:

        ./bootstrap
        ./configure --help

    And then choose the options you wish, and follow the rest of the instructions in the `INSTALL` file.

Updating from an older version of the patches
---------------------------------------------

The recommended method is to delete your old clones and make new ones, following the instructions from the new patchset.  This is the simplest method to get everything identical to the expected configuration.

Alternately, you can try updating in-place as follows:

    cd etherlab
    hg qpop -a
    hg pull -u --mq

At this point you will have the new patches; read the new `.hg/patches/README.md` to see if it's based on the same upstream or not; do the following to update the upstream if necessary:

    hg pull
    hg update 5a70ffc4

(Remember to use the hash from the new README.)  And finally apply the new patches with:

    hg qpush -a

Patch list
----------

##### 0001-Distributed-Clock-fixes-and-helpers.patch

Adds ecrt_master_setup_domain_memory and ecrt_master_deactivate_slaves; fixes up application-selected reference clocks.

##### 0002-Distributed-Clock-fixes-from-Jun-Yuan.patch

This sorts out some timing issues to do with slave dc syncing.

##### 0003-Do-not-reuse-the-index-of-a-pending-datagram.patch

Do not reuse the index of a pending datagram, to prevent corruption.

##### 0004-If-enable-rtmutex-use-rtmutexes-instead-of-semaphore.patch

Configure option `--enable-rtmutex` makes the master use rtmutexes instead of regular semaphores.  This provides priority inheritance to reduce latency on lock contention.

##### 0005-Support-for-multiple-mailbox-protocols.patch

When reading a slave mailbox it may return a response for any prior request in any order, or an unsolicited response (eg. EoE, CoE emergency).  This patch routes the data according to protocol type so that the FSMs do not get confused as long as only one request for any given protocol is in flight for a given slave at a time.

##### 0006-Await-SDO-dictionary-to-be-fetched.patch

Requests are not processed until the SDO dictionary finishes fetching, to avoid timeouts.

##### 0007-Protection-of-external-datagram-queue.patch

Protect external datagram queue.

##### 0008-Clear-slave-mailboxes-after-a-re-scan.patch

When rescanning a slave (and thus discarding any prior pending FSMs), explicitly clear the slave mailbox, to avoid getting confused by a stale response.

##### 0009-Skip-output-statistics-during-re-scan.patch

UNMATCHED datagrams are expected during a rescan; don't report them.

##### 0010-Sdo-directory-now-only-fetched-on-request.patch

Only fetch the SDO dictionary when explicitly requested by the tool.  This improves scan performance since it can be quite time consuming, and after initial commissioning it is usually not required.

##### 0011-Master-locks-to-avoid-corrupted-datagram-queue.patch

Adds locks to protect functions that are likely to be called from multiple concurrent application tasks.  In some cases applications may still require external locks.

##### 0012-Ignore-mailbox-settings-if-corrupted-sii-file.patch

Ignore SII specified mailbox settings if they appear to be from blank EEPROM.

##### 0013-Improved-EtherCAT-rescan-performance.patch

If a slave has an alias or serial number (and can thus be uniquely identified on the network even if its position changes), its SII can be cached to avoid re-reading it.  This improves scan performance, particularly on larger networks.

##### 0014-Fix-NOHZ-local_softirq_pending-08-warning.patch

Fix NOHZ kernel warning in debug interface.

##### 0015-EoE-processing-is-now-only-allowed-in-state-PREOP.patch

EoE is disabled in INIT, BOOT, and invalid states to prevent errors.

##### 0016-Prevent-abandoning-the-mailbox-state-machines-early-.patch

Fixes the exit condition of the mailbox FSMs -- previously they returned whether they were sending a datagram or not, and the parent assumed that this meant they were done if they didn't want to send a datagram.  Since earlier patches can cause idle cycles now, this could cause unexpected early exit, so they now return whether they're complete or not explicitly.

##### 0017-Make-busy-logging-a-little-less-irritating.patch

This makes changeset [a2701a] "Internal SDO requests now synchronized with external requests." a bit less noisy.
[a2701a]:https://sourceforge.net/p/etherlabmaster/code/ci/a2701a/tree/

##### 0018-Clear-configuration-on-deactivate-even-if-not-activa.patch

Clears the master configuration when `ecrt_master_deactivate()` is called even if `ecrt_master_activate()` has not been called prior (though it still logs a warning).  In particular, this allows creating slave configs and request objects and then discarding them, eg. to use the async APIs prior to starting the realtime loop.

##### 0019-After-a-comms-interruption-allow-SAFEOP-OP-directly-.patch

Allows a slave in SAFEOP+ERR with Sync Watchdog Timeout state (0x001B) to transition straight back to OP (do not pass through PREOP, do not reconfigure).  This lets a device recover faster from a comms interruption that doesn't cause a network structure change.

As a side benefit it also caches the last AL status code from the slave, which could potentially be made available to the application (although this patch does not do so).

##### 0020-Adding-some-more-state-to-avoid-calling-the-more-exp.patch

Adds some extra fields to the ecrt.h interface so the application can know a bit more about what's going on and whether requests are likely to take a while to start.

##### 0021-Detect-bypassed-ports-timestamp-not-updated.patch

When doing delay measurement, detects ports that are completely bypassed (eg. by a slave-based redundant ring topology), allowing them to be ignored rather than using invalid timestamps.

##### 0022-Calculate-most-likely-upstream-port-for-each-slave.patch

Indicates the most-likely upstream port for each device.  Normally this should always be 0, but it can sometimes be 1-3 if a device has been connected backwards accidentally or as a result of active redundancy.  Useful for diagnostics.

##### 0023-Print-redundancy-device-name-with-ring-positions-as-.patch

Changes several places where a slave's ring position is logged to also display the link name ("main" or "backup").  This is because when master-port redundancy was active, the first slave responding on each link would both have been "0-0" previously; now one is "0-main-0" and the other is "0-backup-0".  This will still affect the log output even if redundancy is not enabled.

##### 0024-RX-does-not-reset-watchdog-breaks-redundancy.patch

Fixes the e1000e driver watchdog (particularly helps for master-side redundancy, but also kicks it off the realtime thread).

##### 0025-Add-command-to-request-hardware-reboot-for-slaves-th.patch

Adds `reboot` command to tool, to perform software reboot of slaves that support this (via register 0x0040).

##### 0026-Add-register-read-write-support.patch

* Adds `ecrt_reg_request_readwrite` API to perform register read+write requests (writes register data and reads back the prior values in a single datagram).

* Adds `reg_rdwr` command to tool which does the same from the command line.

This can be useful to ensure that the data is coherent and you don't miss an update; particularly useful for read+clear on error counters.

##### 0027-Display-more-info-about-the-register-requests-in-pro.patch

Adds some additional level 1 logging for register requests.

##### 0028-Support-SDO-upload-via-complete-access.patch

* Adds `ecrt_master_sdo_upload_complete` sync API to read an entire object from a slave via SDO Complete Access (where supported by the slave, although most do).

* Adds complete access functionality to tool `upload` command.  This defaults to the `octet_string` data type so that it can more easily be written to a file or otherwise processed (eg. `ethercat upload -p0 INDEX | hd` will format the data nicely).

As with the existing download functionality only Complete Access from subindex 0 is supported.

##### 0029-Avoid-changing-running-slaves-DC-offset.patch

If the network rescans while the master app is running [eg. due to a change in the number of responding slaves], then without any patch the reconfig process is likely to update the System Time Offset register, which causes an immediate step change in the slave’s DC clock and can in turn sometimes result in it missing pulses and possibly stopping altogether.)

* If the System Time Offset and Delay registers for a given slave are already correct, it will not write to them at all.
* If it wants to change the System Time Offset register but the slave is already in SAFEOP or OP, then it won’t change it (but will still update the System Time Delay with the transmission delay).
    * Modifying the System Time Offset register (0x0920) causes a step change in the System Time of the slave, which can cause it to miss the next sync time (for a 32-bit slave, it can take 4 seconds to recover, and for a 64-bit slave, it might never sync again).
    * Modifying the System Time Delay register (0x0928) just alters the value it uses when the normal time sync datagram circulates (as far as I can tell); this is drift compensated so it will gradually drift to the correct time instead of stepping straight to it, so shouldn't cause the above problem.
    * Patches 0001 and 0002 both make it more likely for the master to want to update the System Time Offset (though they do improve other things, and this is good for the initial startup case – just less so for the reconfigure-during-OP case).
* If it updated either the offset or the delay it will also write register 0x0930 to reset the drift filter (this is recommended in the datasheets).

This should now be cleaner and safer than the previous version of this patch (which disabled and re-enabled sync outputs, which only works if the slave supports and enables AssignActivate 0x2000 and might miss some pulses), and better for general use, since this allows running slaves to always use drift compensation to adjust their clocks gradually rather than stepping instantly (while slaves being configured from PREOP can still step immediately).

The patch now applies to all DC-capable slaves – previously it only affected slaves that use sync pulse generation (AssignActivate 0x0100), but step changes can be a problem for slaves that perform DC timestamping or other things too.

It should also avoid DC timing shifts during operation, especially if you are using a slave as the reference clock and syncing the master clock to it rather than the reverse.  (Note that the dc_user example code does do the reverse and actually uses the master clock as the real reference.  If you’re not sure which is which, using ecrt_master_reference_clock_time to get the slave refclock time and use it in the master code is the former, while using ecrt_master_sync_reference_clock to send the master clock to the slave refclock is the latter.  Both approaches should be safe but the latter is subject to higher jitter and drift.)

However bear in mind that the way I’m using DC I’m not going to notice small timing errors.  So I’d appreciate it if someone who is using DC more extensively (especially with motor slaves, which tend to be picky) could verify it.

##### 0030-Use-call-back-functions.patch

Ensures that we use the call back functions (with io lock support) when using the IOCTL interface.

##### 0031-Added-newline-to-syslog-message-MAC-address-derived.patch

Added newline to syslog message "MAC address derived ..."

##### 0032-Correction-to-Clear-slave-mailboxes-after-a-re-scan.patch

The slaves mailbox data is now assumed valid even if the slave scanning skip the states concerning clearing of slave mailboxes (e.g. if the slave refuses to enter state PREOP due to a corrupted slave application firmware). The previous assumption could prevent a new upgrade of valid firmware using FoE.

##### 0033-Corrected-debug-level-for-Aborting-dictionary.patch

Corrected debug level for "Aborting dictionary ..."

##### 0034-Tool-Withdraw-EEPROM-control-for-SII-read-write.patch

The PDI EEPROM control is now withdrawn for all normal SII read and write operations unless EEPROM has been locked by PDI. An EEPROM locked by the PDI can however still be withdrawn using the force option on the SII read and write operations.

##### 0035-Add-support-for-bringup-up-network-interface-when-st.patch

Add support for bringup up network interface when starting EtherCAT.

##### 0036-Reduced-printing-to-avoid-syslog-spam.patch

Removed unecessary printf in lib/master.c and printk in ioctl.c to avoid syslog spam. If ECAT_GetSlaveInfo in system SW is called on a slave that does not exist you get a printf to stderr and printk in syslog. This is however done every 10ms on each IO card in some applications. The already returned error code is enough for proper error handling.

##### 0037-rt_mutex_lock_interruptible-calls-for.patch

`rt_mutex_lock_interruptible` calls for new kernels.  From 3.17 and 3.14.34-rt32, the `detect_deadlock` argument was dropped

##### 0038-Breaking-change-require-data-size-to-be-specified-in.patch

[Breaking API change]
Modifies the `ecrt_sdo_request_write` API to also include the size of data to be written (this must be less than or equal to the size specified at the time the request was created).

Combined with the existing `ecrt_sdo_request_index` API, this allows you to re-use one request object for any SDO on the same slave, provided the initial size is large enough.

Previously you had to use at least one object per different object size, as there was no way to set the write size other than at creation time, and the write size was also altered whenever you did a read.

##### 0039-Breaking-change-Support-for-SDO-complete-access-in-e.patch

[Breaking API change]
Extends patch 0028 to support async Complete Access as well, by adding a parameter to the  `ecrt_slave_config_create_sdo_request` and `ecrt_sdo_request_index` APIs.

##### 0040-rescan-check-revision.patch

Modifies patch 0013 in four ways:

1. The SII cache-and-reuse behaviour can be disabled via `--disable-sii-cache` at configure time, rather than requiring modifying a header file.
2. The revision number is also verified before using the cached version (this resolves some issues when the device firmware is upgraded).
3. If both the alias and serial are read as 0, it will no longer bother reading the vendor/product/revision, as it is now known that the SII is not in the cache.
4. Several similar states are consolidated into one.

##### 0041-load-sii-from-file.patch

Adds the ability to override the slave's SII data with a file (useful if the slave's SII EEPROM is too small to hold the correct data).

* The functionality is disabled by default.
* At configure time, you can use `--enable-sii-override` to activate it, using the standard udev/hotplug lookup process.
* At configure time, you can use `--enable-sii-override=/lib/firmware` (or another path) to activate it using a direct loading method.
* It will cooperate as expected with patch 0013, although note that it’s not as efficient as it could be (it will reload some of the values that patch 0013 already read when checking the SII cache; but trying to improve this would make the code really awkward).

##### 0042-print-sync-signed.patch

Corrects the DC sync log message to use signed format, since it can be given negative values.

##### 0043-ethercat-diag.patch

Adds a `diag` command to the tool which queries slaves' error counter registers to help locate lost links and other network faults.

##### 0044-diag-readwrite.patch

Modifies the prior patch to use patch 0026's `reg_rdwr` functionality to improve atomicity of read+reset requests.

##### 0045-slave-config-position.patch

Adds a `position` field to the structure returned by `ecrt_slave_config_state`.  This allows you to quickly get the ring position of a slave from its relative alias:offset address, which in turn allows you to call other APIs that require this (eg. `ecrt_master_get_slave`).

Note that the `position` is only valid if `online` is true, and that it's possible for the value to be stale (ie. the slave has moved to some other position in the meantime).

##### 0046-e1000e-link-detection.patch

Fixed link detection in e1000e driver for 3.10-3.16.

##### 0050-fsm_sii_external-datagram.patch

Prep for a later patch: make `fsm_sii` use an external datagram.

##### 0051-fsm_change-external-datagram.patch

Prep for a later patch: make `fsm_change` use an external datagram.

##### 0052-fsm_slave_config-external-datagram.patch

Prep for a later patch: make `fsm_slave_config` use an external datagram.

##### 0053-fsm_slave_scan-external-datagram.patch

Prep for a later patch: make `fsm_slave_scan` use an external datagram.

##### 0054-fsm_slave-handles-all-sdos.patch

This moves the internal SDO requests and SDO dictionary requests (if you disable `EC_SKIP_SDO_DICT` from patch 0010; otherwise dictionary requests already were effectively moved) from `fsm_master` into `fsm_slave`.

This does two important things: firstly it removes the fighting over the CoE mailbox between the internal and external SDO requests (making the busy-checking on each side unnecessary).  And secondly it allows both of these to occur in the background and in parallel between multiple slaves.

##### 0055-fsm_slave_config_scan-to-fsm_slave.patch

Similar to the previous patch, this moves `fsm_slave_scan` and `fsm_slave_config` from fsm_master to fsm_slave.  This allows slave scanning and configuration to occur in parallel for multiple slaves.  (Note that scanning all slaves must complete before configuring any slave can begin.)

This also adds `scan_required` to `ec_slave_info_t`; when true the other fields are unreliable (and should be ignored) as scanning has not yet started or is still in progress.

The motivating case was a network of about 100 slave devices; while scanning is fast (under a second for a "hot" network with aliases/serials on all devices, after prior SII patches), the configuration process to bring the slaves from PREOP to OP took about 80 seconds (and you could see the lights coming on each slave in sequence).  After the patch it takes about 20 seconds.

I actually originally intended to only move `fsm_slave_config`, but the structure of the code required moving `fsm_slave_scan` as well.  Logically they do both belong in the slave FSM anyway.

Note that in this case "parallel" does not mean separate threads – all the FSMs (master and all slaves) still execute on a single thread.  But it can now include datagrams for multiple slaves in the same frame.  The existing throttling mechanism for `fsm_slave` is used, so it will configure slaves in chunks, not all at once (so the network won’t get overloaded if you have a large number of slaves, though network usage will be higher than it previously was).

##### 0056-fsm-exec-simplify.patch

Now that most of the FSMs execute from `fsm_slave`, it’s not necessary for them to check the datagram state, as master.c’s `ec_master_exec_slave_fsms` does this in advance.  This simplifies the FSM exec functions.

##### 0057-fsm_foe-simplify.patch

* Removes some redundant fields from the FoE FSM; some were unused copy/paste holdovers from the CoE FSM while others were duplicated unnecessarily between the read and write operations, which can’t be concurrent for a given slave anyway.

* Fixes the case where the incoming data exceeds the provided buffer to properly terminate the state machine instead of leaving things dangling.  Although note that this still leaves the FoE conversation itself dangling, so you’ll likely get an error on the next request if this occurs.

##### 0058-foe-password.patch

* Adds support for sending an FoE password along with read or write requests.

* Implements the `-o` option for the `foe_read` command (which was documented but not implemented).

* Makes the ioctl behind `foe_read` actually use the buffer size requested by the caller (instead of a hard-coded value); though note that `foe_read` itself still uses a hard-coded value of its own (but it’s larger, so bigger files should be readable now).  It’s possible that users on limited-memory embedded systems might need to reduce this value, but it’s still fairly conservative as RAM sizes go.

##### 0059-foe-requests.patch

Makes FoE transfer requests into public `ecrt_`* API, similar to SDO requests.

Primarily (following my goal of “parallel all the things”), this allows FoE transfers to be non-blocking so that transfers to multiple slaves can occur concurrently from the same requesting thread (previously this was only possible by using separate threads, since the only API was blocking).  Note that due to patch 0018 you can call `ecrt_master_deactivate()` to delete these requests when you’re done with them, even if you haven’t called `ecrt_master_activate()` yet.

It has a possible side benefit that FoE transfers can now be started and monitored from realtime context, although as FoE is mostly used for firmware updates this is unlikely to be all that useful in practice.

##### 0060-foe-request-progress.patch

Adds a way to get a “current progress” value (actually the byte offset) for async FoE transfers.
